(function () {
    
    var setEditorMode = function(editor, language) {
        
        var mode = 'text';
        var loadModules = [];
        
        switch(language) {
            case 'C#':
                mode = 'text/x-csharp';
                loadModules.push('clike');
                break;
                
            case 'Java':
                mode = 'text/x-java';
                loadModules.push('clike');
                break;
                
            case 'JavaScript':
                mode = 'text/javascript';
                loadModules.push('javascript');
                break;
                
            case 'Perl':
                mode = 'text/x-perl';
                loadModules.push('perl');
                break;
                
            case 'PHP':
                mode = 'application/x-httpd-php';
                loadModules.push('htmlmixed');
                loadModules.push('xml');
                loadModules.push('javascript');
                loadModules.push('clike');
                loadModules.push('php');
                break;
                
            case 'Python':
                mode = 'text/x-python';
                loadModules.push('python');
                break;
                
            case 'Ruby':
                mode = 'text/x-ruby';
                loadModules.push('ruby');
                break;
                
            case 'VB':
                mode = 'text/x-vb';
                loadModules.push('vb');
                break;
                
            case 'VBScript':
                mode = 'text/vbscript';
                loadModules.push('vbscript');
                break;
                
            default:
                break;
        }
        
        editor.setOption("mode", mode);
        for (var i = 0; i < loadModules.length; i++) {
            CodeMirror.autoLoadMode(editor, loadModules[i]);
        }
    }
        
    
    
    var setupCodeMirror = function (textArea, language) {
        
        var setup = function (textArea, language) {
            var editor, hlLine;
            editor = CodeMirror.fromTextArea(textArea, {
                mode: { name: language },
                matchBrackets: true,
                lineNumbers: true,
                indentUnit : 4
            });
            
            textArea.changeMode = function (language) {
                setEditorMode(editor, language);
            };
            textArea.changeMode(language);
            editor.setCursor(0);
        };
        
        var static = document.getElementById("static-path").value.split('LICENSE')[0];
        CodeMirror.modeURL = static + "mode/%N/%N.js";
        setup(textArea, language);
    };
  
    var setUpTextArea = function (textArea) {
        if (textArea.innerHTML === "") {
            textArea.innerHTML = "\n\n\n\n";
        }
        setupCodeMirror(textArea, "Python");
    };
    
    var textArea = document.getElementById("lang-document");
    setUpTextArea(textArea);
    
    var combo = document.getElementById("lang-select");
    console.log(combo.value);
    
    combo.onchange = function() {
        textArea.changeMode(combo.value);
    };
    
    
}());
